/**
 * 
 */
package packageTp1;

import java.util.ArrayList;

/**
 * @author Yann Thorimbert
 *
 */

public class Polynomial {

	private ArrayList<Monomial> monomials = new ArrayList<Monomial>();

	public Polynomial() {
	}
	
	public void addMonomial(Monomial m) {
		if(this.monomials.size()>0) {
			Monomial lastMonomial = this.monomials.get(this.monomials.size()-1);
			int lastPower = lastMonomial.getPower();
			if(lastPower > m.getPower())
				throw new IllegalArgumentException("New monomial is of lower power.");
			else if(lastPower == m.getPower())
				this.monomials.set(this.monomials.size()-1, lastMonomial.add(m));
			else
				this.monomials.add(m);
		}
		else
			this.monomials.add(m);
	}
	
	public String toString() {
		String s = "";
		int i = 0;
		for (Monomial m: this.monomials) {
			if(i>0) {
				if(m.getCoeff() > 0)
					s += " + ";
				else
					s += " - ";
			}
			s += m.toString();
			i++;
		}
		return s;
	}
	
	
}
